package com.blueland.bpm.manage.config.web;

import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.support.RedirectAttributes;

import com.blueland.bpm.common.base.BaseSpringController;
import com.blueland.bpm.common.page.Page;
import com.blueland.bpm.common.util.HttpUtils;
/**
 * @author lw
 * @version 1.0
 * @since  
 */
import com.blueland.bpm.engine.config.model.DataObject;
import com.blueland.bpm.engine.config.service.DataObjectManager;
import com.blueland.bpm.manage.util.BaseUser;

@Controller
@RequestMapping(value = "dataObject")
public class DataObjectController extends BaseSpringController{
	//默认多列排序,example: username desc,createTime asc
	protected static final String DEFAULT_SORT_COLUMNS = null; 
	@Autowired
	private DataObjectManager dataObjectManager;
	
	private final String LIST_ACTION = "redirect:/dataObject/list.do";
	
	public DataObjectController() {
	}
	

	/**
	 * 增加了@ModelAttribute的方法可以在本controller的方法调用前执行,可以存放一些共享变量,如枚举值
	 */
	@ModelAttribute
	public void init(ModelMap model) {
		//model.put("now", new java.sql.Timestamp(System.currentTimeMillis()));
	}
	
	/** 
	 * 执行搜索 
	 **/
	@RequestMapping(value = "list")
	public ModelAndView list(HttpServletRequest request,DataObject query) {
		Page page = this.dataObjectManager.findPage(query);
		ModelAndView result = new ModelAndView("/dataObject/list");
		result.addAllObjects(toModelMap(page, query));
		return result;
	}
	
	/** 
	 * 查看对象
	 **/
	@RequestMapping(value = "show")
	public ModelAndView show(HttpServletRequest request)  {
		String id = new String(request.getParameter("objId"));
		DataObject dataObject = (DataObject)dataObjectManager.getById(id);
		return new ModelAndView("/dataObject/show","dataObject",dataObject);
	}
	
	/** 
	 * 进入新增页面
	 **/
	@RequestMapping(value = "create")
	public ModelAndView create(HttpServletRequest request,DataObject dataObject)  {
		return new ModelAndView("/dataObject/create","dataObject",dataObject);
	}
	
	/** 
	 * 保存新增对象
	 **/
	@RequestMapping(value = "save")
	public ModelAndView save(HttpServletRequest request,DataObject dataObject,RedirectAttributes redirectAttributes)  {
		dataObject.setTenantId(BaseUser.getInstance().getLoginUserAppId(request));
		dataObjectManager.save(dataObject);
		redirectAttributes.addFlashAttribute(ACTION_MESSAGE, CREATED_SUCCESS);
		return new ModelAndView(LIST_ACTION);
	}
	
	/**
	 * 进入更新页面
	 **/
	@RequestMapping(value = "edit")
	public ModelAndView edit(HttpServletRequest request)  {
		String id = new String(request.getParameter("objId"));
		DataObject dataObject = (DataObject)dataObjectManager.getById(id);
		return new ModelAndView("/dataObject/edit","dataObject",dataObject);
	}
	
	/**
	 * 保存更新对象
	 **/
	@RequestMapping(value = "update")
	public ModelAndView update(HttpServletRequest request,DataObject dataObject,RedirectAttributes redirectAttributes)  {
		String id = new String(request.getParameter("objId"));
		dataObjectManager.update(dataObject);
		redirectAttributes.addFlashAttribute(ACTION_MESSAGE, UPDATE_SUCCESS);
		return new ModelAndView(LIST_ACTION);
	}
	
	/**
	 *删除对象
	 **/
	@RequestMapping(value = "delete")
	public ModelAndView delete(HttpServletRequest request,RedirectAttributes redirectAttributes) {
		String[] items = request.getParameterValues("items");
		for(int i = 0; i < items.length; i++) {
			Hashtable params = HttpUtils.parseQueryString(items[i]);
			
			String id = new String((String)params.get("objId"));
			
			dataObjectManager.removeById(id);
		}
		redirectAttributes.addFlashAttribute(ACTION_MESSAGE, DELETE_SUCCESS);
		return new ModelAndView(LIST_ACTION);
	}
	
}

